/*
 *  Simple test program -- simplified version of sample test hello.
 */

#define TEST_INIT

#include <stdio.h>
#include <bsp.h>

#include <rtems/untar.h>
#include <imfs.h>
#include <libstab.h>
#include <assert.h>
#include <unistd.h>
#include <sys/stat.h>
#include <sys/types.h>
#include <sys/stat.h>


extern int shellMain();
extern void system_symbol_table_init();
extern void debugInit();

extern int _binary_tarfile_start;
extern int _binary_tarfile_size;


static void fsInit(){
  rtems_filesystem_mount_table_entry_t *mt_entry;
  int status;
  struct stat buf;

  assert(chdir( "/" ) == 0);
  assert(mkdir( "/imfs", 0777 )==0);
  status = mount(&mt_entry,
		 &IMFS_ops,
		 RTEMS_FILESYSTEM_READ_WRITE,
		 NULL,
		 "/imfs" );
  printf("mount() - status = %d\n", status);
  assert(chdir( "/imfs" ) == 0);
  status = Untar_FromMemory((unsigned char *) (&_binary_tarfile_start),
			    (int) &_binary_tarfile_size);
  printf("Untar_FromMemory() - status = %d\n",status);

  if(stat("/imfs/hello_test.o", &buf)==0){
    printf("/imfs/hello_test.o %d\n", buf.st_size);
  }else{
    printf("fsinit() - ERROR - stat()\n");
  }
}


rtems_task Init(rtems_task_argument ignored){
  printf( "\n\n*** ESH TEST ***\n" );

  system_symbol_table_init();     /* Initialize the symbo table */
  debugInit();                    /* Initialize the disassembler */
  fsInit();                       /* initialize the file system */
  
  shellMain();

  printf( "*** END OF ESH TEST ***\n" );

  exit( 0 );
}

/* configuration information */

#define CONFIGURE_APPLICATION_NEEDS_CONSOLE_DRIVER
#define CONFIGURE_APPLICATION_NEEDS_CLOCK_DRIVER
#define CONFIGURE_MAXIMUM_TASKS             10
#define CONFIGURE_RTEMS_INIT_TASKS_TABLE
#define CONFIGURE_EXTRA_TASK_STACKS         (3 * RTEMS_MINIMUM_STACK_SIZE)
#define CONFIGURE_INIT
#define CONFIGURE_USE_IMFS_AS_BASE_FILESYSTEM
#define CONFIGURE_LIBIO_MAXIMUM_FILE_DESCRIPTORS 10

#include <confdefs.h>

/* end of file */
