#include <stdio.h>
#include <string.h>
#include "libstab.h"
#include "libld.h"
#include <regexp.h>

int ld(char *name){
  return loader_load(name);
}

int unld(int handle){
  return loader_unload(handle);
}

static void print_item(stab_entry *i){
  printf("0x%08x: %s\n", i->address,i->name);
}

static int lkup_match(stab_t *stab, stab_entry *i, regexp *expression){
  if (regexec(expression, i->name)==1){
    print_item(i);
  }
  return 1;
}

int lkup(char *pattern){
  regexp *expression;	/* compiled search pattern */

  if(pattern==0){
    return 0;
  }

  expression = regcomp(pattern);

  stab_for_each(system_symbol_table,
		(stab_proc)lkup_match,
		(unsigned long)expression);

  free(expression);
  return 1;
}

int lkAddr(void *addr){
  stab_entry *i;

  if(i = stab_find_by_addr(system_symbol_table,addr))
    print_item(i);
  
  return 1;
}
