#include <stdarg.h>
#include <ctype.h>

#define IS_PRINT(x) ((32 <= x) && (x <= 126))

static void
to_hex(unsigned char const value, char *str) {
  static char const hexchars[]="0123456789abcdef";

  str[0] = hexchars[(value / 16)];
  str[1] = hexchars[(value % 16)];
}


static void
hex_dump_line(char const *addr, unsigned char const *buf, int const len, char *str)
{
  int i = 0;
  char *d = str;
  char *a = &str[55];
  
  memset(str,' ',80);
  
  // print the address:
  sprintf(str, "0x%08x", buf);
  str[10]=' ';
  d = str + 11;
  
  // print the data in hex, two bytes at a time:
  // print the data in ascii, translating non-ascii to '.':
  i = 0;
  while(i < len){
    if(!(i%2)) d++;
    to_hex(buf[i],d);
    d += 2;
    *a++ = IS_PRINT(buf[i])?buf[i]:'.';
    i++;
  }
  
  d=&str[54];
  *d++ = '[';
  a=&str[71];
  *a++ = ']';
  *a++ = 0;
}

/*VARARGS1*/
void d(unsigned char *the_buf, ...)
{
  va_list ap;
  int i = 0;
  int count = 16 /* bytes / line */ * 10 /* lines */;
  char buffer[80];
  int first_time = 1;
  int do_compare = 0;
  static unsigned char* last_buf = (unsigned char *)100L;

  /* args */
  unsigned char *buf = the_buf;
  int len;

  va_start(ap, the_buf);
  if(the_buf==0)
    buf = last_buf;
  if((len = va_arg(ap, int))<=0)
    len = count;
  va_end(ap);

  while((count -= 16) >= 0){
    if(do_compare){
      if(memcmp(&buf[i], &buf[i-16], 16)==0) {
        if(first_time){
          printf("*\n");
          first_time = 0;
        }
      }else{
        hex_dump_line((char*)i,&buf[i],16,buffer);
        printf("%s\n", buffer);
        first_time = 1;
      }
    }else{
        hex_dump_line((char*)i,&buf[i],16,buffer);
        printf("%s\n", buffer);
        first_time = 1;
        do_compare = 1;
    }
    i += 16;
  }
  if (len % 16){
    hex_dump_line((char*)(16 * (len / 16)),&buf[16 * (len / 16)],len % 16,buffer);
    printf("%s\n", buffer);
  }
  last_buf = &buf[len];
}

/* End of hex_dump.C */
