#include <stdio.h>
#include <string.h>
#include <libstab.h>
#include "loaderProcs.h"
#include "loader.h"

LOOKUP sysLookupTab[] = {
   SYMFUNC(printf)
   { 0, 0 },
};

stab_t *system_symbol_table;

int main(int argc, char *argv[]){
  int errmaj, errmin;
  int wasLoaded = 0;
  int handle;
  void (*proc)(void);

  system_symbol_table = stab_create(1024);

  LoaderInit();
  LoaderAddSymbols(-1, -1, sysLookupTab);
  handle = LoaderOpen(argv[1],argv[1],0,&errmaj, &errmin, &wasLoaded);
  LoaderCheckUnresolved(LD_RESOLV_FORCE);
  
  if(proc = LoaderSymbol (argv[2])){
    proc();
  }else{
    printf("ERROR: symbol \"%s\" not found\n",argv[2]);
    return 1;
  }
  
  return 0;
}
