/*****************************************************************
*
* File:      $Id: find_by_addr.c,v 1.2 2002/09/16 00:32:31 glenco Exp $
* Version:   $Version$
* Author:    G. Cornell
*
*****************************************************************
*
* $Log: find_by_addr.c,v $
* Revision 1.2  2002/09/16 00:32:31  glenco
* Adding example program and improving mkstab
*
* Revision 1.1.1.1  2002/08/29 02:48:57  glen
* initial import into CVS
*
* Revision 1.1  2002/06/14 21:38:17  cornell
* initial version
*
*
*
*****************************************************************/

#include <libstab.h>
#include <libstabP.h>

typedef struct {
  void *search_key;
  stab_entry *closest_sym;
}find_t;

static int stab_find_proc(stab_t *stab, 
			  stab_entry *sym,
			  find_t *data){
  if(sym->address <= data->search_key){
    if(data->closest_sym == 0 || sym->address > data->closest_sym->address){
      data->closest_sym = sym;
    }
  }
  return 1;
}

stab_entry *stab_find_by_addr(stab_t  *stab,
			      void    *address){
  find_t data = { address, 0 };
  stab_for_each(stab, (stab_proc)stab_find_proc, (unsigned long)&data);
  return data.closest_sym;
}
