/*****************************************************************
*
* File:      $Id: for_each.c,v 1.2 2002/09/16 00:32:31 glenco Exp $
* Version:   $Version$
* Author:    G. Cornell
*
*****************************************************************
*
* $Log: for_each.c,v $
* Revision 1.2  2002/09/16 00:32:31  glenco
* Adding example program and improving mkstab
*
* Revision 1.1.1.1  2002/08/29 02:48:57  glen
* initial import into CVS
*
* Revision 1.1  2002/06/14 21:38:17  cornell
* initial version
*
*
*
*****************************************************************/

#include <libstab.h>

stab_entry *stab_for_each(stab_t        *stab,
			  stab_proc      proc,
			  unsigned long  user_data){
  int i;
  stab_entry *sym;
  stab_entry *next;

  for(i = 0; i < stab->num_buckets; i++){
    sym = stab->buckets[i];
    while(sym){
      next = sym->next;
      if (!proc(stab,sym,user_data))
	return sym;
      sym = next;
    }
  }
  return 0;
}

