/*****************************************************************
*
* File:      $Id: insert.c,v 1.2 2002/09/16 00:32:31 glenco Exp $
* Version:   $Version$
* Author:    G. Cornell
*
*****************************************************************
*
* $Log: insert.c,v $
* Revision 1.2  2002/09/16 00:32:31  glenco
* Adding example program and improving mkstab
*
* Revision 1.1.1.1  2002/08/29 02:48:57  glen
* initial import into CVS
*
* Revision 1.1  2002/06/14 21:38:17  cornell
* initial version
*
*
*
*****************************************************************/

#include <stdlib.h>
#include <string.h>
#include <libstab.h>
#include <libstabP.h>

int stab_insert(stab_t        *stab,
		char	      *name,
		void	      *address,
		int	       type,
		int	       handle,
		int	       module){
  int i = stab_hash(stab,name);
  stab_entry *sym;
  
  if(stab_find_by_name(stab, name) && !stab->multiple_symbols_allowed)
    return -1;
  
  if((sym = (stab_entry*)malloc(sizeof(stab_entry)))==0)
    return -1;

  sym->next          = stab->buckets[i];
  sym->name          = strdup(name);
  sym->address       = address;
  sym->type          = type;
  sym->module        = module;
  sym->handle        = handle;
  stab->buckets[i]   = sym;

  return 0;
}

