#include <stdio.h>
#include <unistd.h>
#include <libstab.h>

static int print_sym(stab_t *stab, stab_entry *sym, unsigned long x){
  printf("%s\t%d\n", sym->name, sym->address);
  return 1;
}

int main(){
  FILE *fp;
  char word[80];
  int i = 1;
  stab_t *stab = 0;

  if((stab = stab_create(1024))==0){
    fprintf(stderr, "stab_create()\n");
    return 1;
  }

  if((fp= fopen("/usr/dict/words","r"))==0){
    fprintf(stderr,"unable to open dictionary\n");
    return 1;
  }

  while(!feof(fp)){
    fgets(word,sizeof(word),fp);
    word[strlen(word) - 1] = 0;
    stab_insert(stab,word,(void*)i++,N_DATA,0,0);
  }

  stab_for_each(stab,print_sym,0);

  print_sym(stab, stab_find_by_name(stab,"angular"), 0);
  print_sym(stab, stab_find_by_addr(stab,(void*)972), 0);

  stab_destroy(stab);

  return 0;
}
